/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;using System;namespace PluginIdea.SlideControl{public class CameraViewModule : SlideModuleBase{public Action<Texture> onCameraTexSettedEvent;private Dictionary<string, Camera> dic_uid2Cam = new Dictionary<string, Camera>();private JSONStorableStringChooser camTargetChooser;private JSONStorableAction refreshCameraTextureAction;private JSONStorableAction refreshCameraListAction;public CameraViewModule(SlideControl ower){this.ower = ower;}public override void Init(){UIInit();}public void RefreshItems(){SuperController.singleton.GetAtomUIDs().ForEach(atomUiD =>{var receivingAtom = SuperController.singleton.GetAtomByUid(atomUiD);foreach (string elem in receivingAtom.GetStorableIDs()){if (elem.Contains("Camera_Marker")){if (!dic_uid2Cam.ContainsKey(receivingAtom.uid)){Camera cam = receivingAtom.reParentObject.Find("object/rescaleObject").GetComponent<Camera>();if (cam != null){dic_uid2Cam.Add(receivingAtom.uid, cam);break;}}}}});if (dic_uid2Cam.Count > 0){camTargetChooser.choices = dic_uid2Cam.Keys.ToList();camTargetChooser.setCallbackFunction(camTargetChooser.val);}}private void UIInit(){refreshCameraTextureAction = Utils.SetupAction(ower, "RefreshCameraTextureAction", () =>{camTargetChooser.setCallbackFunction(camTargetChooser.val);});refreshCameraListAction = Utils.SetupAction(ower, "RefreshCameraListAction", RefreshItems);Utils.CreateSpacer(ower, 20, false);Utils.CreateInfoTextNoScroll(this.ower, Location.GetStr(Location.CameraViewTargetSubtitle), 40, false);Utils.CreateButton(ower, Location.GetStr(Location.RefreshTargetTex), () =>{camTargetChooser.setCallbackFunction(camTargetChooser.val);}, false, ower.bcs);Utils.CreateButton(ower, Location.GetStr(Location.RefreshCameraList), RefreshItems, false, ower.bcs);camTargetChooser = Utils.CreateStringChooser(ower, Location.GetStr(Location.CameraViewTarget), new List<string>(), 0, false, ower.bcs);camTargetChooser.setCallbackFunction = (val) =>{if (string.IsNullOrEmpty(val) || dic_uid2Cam.Count == 0 || !dic_uid2Cam.ContainsKey(val)) return;var cam = dic_uid2Cam[val];if (onCameraTexSettedEvent != null && cam != null && cam.targetTexture != null)                    onCameraTexSettedEvent(cam.targetTexture);};}public override void UnInit(){dic_uid2Cam.Clear();}}}